/* ***************
// orkutbar.js
// Orkut Toolbar main JS file.
//
// Author: Renato Rodrigues (rraver.sp@gmail.com)
//
// Uses code from BBCode by Jed Brown 
// <http://jedbrown.net/mozilla/>
//
****************** */

var OBCode_stringBundle;
var OBCode_Document = null;

var obcode = {
  init: function() {
    OBCode_setupDocument(document);
  },
  
	obShowHide: function() {
		var bar=document.getElementById("orkut-toolbar");
		var btnShow=document.getElementById("btn_obShow");
		bar.setAttribute("collapsed",!bar.collapsed);
		btnShow.setAttribute("collapsed",!btnShow.collapsed);
	},

	promptWindow: function (promptString, initialValue){
		var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		var result = {value:initialValue};
		promptService.prompt(null, "Orkut Toolbar", promptString, result, null, {value:0});		
		
		if (result && result.value != initialValue) { return result.value; }
		else { return null; }
	},

   obcode: function(myCommand, codeType) {
	    var str = null;
	    var theBox = document.commandDispatcher.focusedElement;
    	var oPosition = theBox.scrollTop;
		var oHeight = theBox.scrollHeight;
    
    	//Get Selected text (if selected)
		var startPos = theBox.selectionStart;
    	var endPos = theBox.selectionEnd;
	    str = theBox.value.substring(startPos, endPos);

		str_clipboard = null

		if(codeType == "obcode") { obcode.insertAtCursorSetup(myCommand, str_clipboard, str, theBox); }
		else if(codeType == "obcode-color") { obcode.insertAtCursorSetup('color', myCommand, str, theBox); }
		else if(codeType == "obcode-emoticon") { obcode.insertAtCursor(theBox, " " + myCommand + " "); }
		else{ alert("CodeType not defined !"); }

		var nHeight = theBox.scrollHeight - oHeight;
	    theBox.scrollTop = oPosition + nHeight;
	},
  
    insertAtCursorSetup: function(myCommand, str_clipboard, str, theBox) {
  // Function taken from http://www.alexking.org/blog/2003/06/02/inserting-at-the-cursor-using-javascript/
  // Modified to return cursor to correct place

    switch (myCommand){
      case "bold":
			obcode.insertAtCursor(theBox,"[b]" + str + "[/b]");
			break;
      case "italic":
			obcode.insertAtCursor(theBox,"[i]" + str + "[/i]");
			break;
      case "underline":
			obcode.insertAtCursor(theBox,"[u]" + str + "[/u]");
			break;
      case "color":
			obcode.insertAtCursor(theBox,"[" + str_clipboard + "]" + str + "[/" + str_clipboard + "]");
			break;
      case "linkABC":
			if (!str) { 
				linkTitle = OBCode_stringBundle.getString("obcode.linkTitle");
				str = obcode.promptWindow(linkTitle, ""); 
			}
			if (str) { 
				linkText = OBCode_stringBundle.getString("obcode.linkABC");
				str_link = obcode.promptWindow(linkText, "http://");
				if (str_link) { obcode.insertAtCursor(theBox,"[link=" + str_link + "]" + str + "[/link]"); }
			}
			break;
      case "linkWWW":
  			if (!str) { 
				linkText = OBCode_stringBundle.getString("obcode.linkWWW");
				str = obcode.promptWindow(linkText, "http://");
			}
			if (str) { obcode.insertAtCursor(theBox,"[link]" + str + "[/link]"); }
			break;
      case "obSign":
			obSign = OBCode_stringBundle.getString("obcode.obSign");
			obcode.insertAtCursor(theBox,obSign);
			break;
      default : 
        alert("Error #2"); }
},

  //Thanks to Nick for pointing out this function
  insertAtCursor: function(theBox, aText) {
    try {
      var command = "cmd_insertText";
      var controller = document.commandDispatcher.getControllerForCommand(command);
      if (controller && controller.isCommandEnabled(command)) {
        controller = controller.QueryInterface(Components.interfaces.nsICommandController);
        var params = Components.classes["@mozilla.org/embedcomp/command-params;1"];
        params = params.createInstance(Components.interfaces.nsICommandParams);
        params.setStringValue("state_data", aText);
        controller.doCommandWithParams(command, params);
      }
    }catch (e) {
      dump("Can't do cmd_insertText! ");
      dump(e+"\n")
    }
  },
} 

//May not be needed, but just incase.
function OBCode_setupDocument(aDoc)
{
  OBCode_Document = aDoc;
  OBCode_stringBundle = aDoc.getElementById("obstrings");
}

//Make sure OBCode loads on start-up of browser.
window.addEventListener('load', obcode.init, false); 

//
//Must be optimzed
//

function goURL(url) {
      var newtab = window.getBrowser().addTab(url);
      window.getBrowser().selectedTab = newtab;         
}

function orkutbar_Search(element, SearchType, event) {
    if(SearchType != 'clear') {
        var Criteria = document.getElementById(element);
 		if (SearchType == 'Communities') { window._content.document.location='http://www.orkut.com/CommunitySearch.aspx?q=' + Criteria.value + '&lang=all'; }
		else if (SearchType == 'Friends') {window._content.document.location='http://www.orkut.com/FriendsFind.aspx?q=' + Criteria.value; }
        orkutbar_addtoSearchHistory(element, Criteria.value); }
	else { orkutbar_clearSearchHistory(element) }
}

function orkutbar_addtoSearchHistory(element, term) {
    var Criteria = document.getElementById(element);
    var historyMenu = Criteria.childNodes.item(0);
    var numHistItems = historyMenu.childNodes.length;
    var alreadyInHist = false;
    var i = 0;

    for (i = 0; i < numHistItems; i++) { if (term == historyMenu.childNodes[i].getAttribute("label")) { alreadyInHist = true; } }

    if (!alreadyInHist) {
        var myMenuItem = document.createElement("menuitem");
		var maxHistCnt = 10
        myMenuItem.setAttribute("label", term);
//        myMenuItem.setAttribute("oncommand", "Orkut Search Command must be here");

        if (numHistItems <= 0) { historyMenu.appendChild(myMenuItem); }
        else { historyMenu.insertBefore(myMenuItem, historyMenu.childNodes[0]); }

        numHistItems++;

        if (numHistItems > maxHistCnt) { 
			var numToRemove = numHistItems - maxHistCnt;
            for (i = 1; i <= numToRemove; i++) { historyMenu.removeChild(historyMenu.lastChild); }
        }
    }
}

function orkutbar_clearSearchHistory(element) {
    var Criteria = document.getElementById(element);
    if (!Criteria) {
      mainDoc = top.opener.document;
      Criteria = mainDoc.getElementById(element); }
    if (!Criteria) alert("Can't Clear");

    var historyMenu = Criteria.childNodes.item(0);
    var numHistItems = historyMenu.childNodes.length;

	for (var i = numHistItems - 1; i >= 0; i--) { historyMenu.removeChild(historyMenu.childNodes[i]); }
    Criteria.selectedIndex = -1;
}
